#' Simulated mixed-item format CAT Data
#'
#' This data set contains an item pool information, response data, and examinee's ability estimates.
#'
#' @usage simCAT_MX
#'
#' @format This data includes a list of length three. The first internal object is a data.frame of
#' the item pool consisting of 200 dichotomous items and 30 polytomous items. The dichotomous items were
#' calibrated with the IRT 3PL model and the polytomous items were calibrated with the generalized
#' partial credit model. All polytomous items have three score categories (i.e., 0, 1, 2). The second
#' internal object is the response data set including a sparse response data set of 30,000 examinees
#' for the items in the item pool. The third internal object is the examinee's ability estimates
#' for 30,000 examinees.
#'
#' @author Hwanggyu Lim \email{hglim83@@gmail.com}
#'
"simCAT_MX"
